<?php
namespace Myquest\Libraries;

use Myquest\Libraries\JWT;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DTO\Request;

class JWTChecker extends \Zeedhi\Framework\Events\PreDispatch\Listener {

    /**
     * Listen to request, then throw an exception or
     * continue execution flow according to validity of
     * the token sent through request data.
     *
     * @param Request $request
     */
    public function preDispatch(Request $request) {
        $routePath = $request->getRoutePath();
        $ignoredRoutes = $this-> getIgnoredRoutes();
        if(!in_array($routePath, $ignoredRoutes)){
            $token = isset($request->getParameters()['$token']) ? $request->getParameters()['$token'] : null;

            if(!$token){
                throw new \Exception('FORBIDDEN_ACCESS');       
            } else if(!JWT::validateToken($token)){
                throw new \Exception('INVALID_TOKEN');
            }
            
            $GLOBALS["MyQuestJWT"] = $token;
        }
        
    }

    protected function getIgnoredRoutes (){
        $definedRoutes = ['/login', '/plateImage'];
        $ignoredRoutes = [];
        foreach ($definedRoutes as $key => $value) {
            $ignoredRoutes[] = $value;
            $ignoredRoutes[] = '/index.php'.$value;
        }
        return $ignoredRoutes;
    }
}